/*	ip_var.h	4.5	81/12/02	*/

/*
 * Overlay for ip header used by other protocols (tcp, udp).
 */
struct ipovly {
	caddr_t	ih_next, ih_prev;	/* for protocol sequence q's */
#if pdp11
	u_long  ih_pad;
#endif
	u_char	ih_x1;			/* (unused) */
	u_char	ih_pr;			/* protocol */
	short	ih_len;			/* protocol length */
	struct	in_addr ih_src;		/* source internet address */
	struct	in_addr ih_dst;		/* destination internet address */
};

/*
 * Ip reassembly queue structure.  Each fragment
 * being reassembled is attached to one of these structures.
 * They are timed out after ipq_ttl drops to 0, and may also
 * be reclaimed if memory becomes tight.
 */
struct ipq {
	struct	ipq *next,*prev;	/* to other reass headers */
#if pdp11
	u_long  ipq_pad;
#endif
	u_char	ipq_ttl;		/* time for reass q to live */
	u_char	ipq_p;			/* protocol of this fragment */
	u_short	ipq_id;			/* sequence id for reassembly */
	struct	ipasfrag *ipq_next,*ipq_prev;
					/* to ip headers of fragments */
	struct	in_addr ipq_src,ipq_dst;
};

/*
 * Ip header, when holding a fragment.
 */
struct	ipasfrag {
	u_char	ip_hl:4,
		ip_v:4;
	u_char	ipf_mff;		/* copied from (ip_off&IP_MF) */
	short	ip_len;
	u_short	ip_id;
	short	ip_off;
	u_char	ip_ttl;
	u_char	ip_p;
	u_short	ip_sum;
	struct  ipasfrag *ipf_next;     /* next fragment.  NOTE: must be
					   same offset as ipq_next */
	struct	ipasfrag *ipf_prev;	/* previous fragment */
#if pdp11
	struct  mbuf *ipf_mbuf;         /* actual fragment */
	short   ipf_pad;
#endif
};

struct	ipstat {
	int	ips_badsum;		/* checksum bad */
	int	ips_tooshort;		/* packet too short */
};

#ifdef KERNEL
struct	ipstat	ipstat;
struct	ipq	ipq;			/* ip reass. queue */
struct	ipq	*ip_freef();
u_short	ip_id;				/* ip packet ctr, for ids */
#endif
